﻿using System;
using System.Text;
using System.Collections.Generic;

namespace IdeaPocsag
{
    public sealed class Crypto
    {
        private List<string> _keys = new List<string>();

        private Crypto()
        { }

        private static volatile Crypto instance = null;

        public static Crypto GetInstance()
        {
            // DoubleLock
            if (instance == null)
                lock (m_lock) { if (instance == null) instance = new Crypto(); }
            return instance;
        }

        // Hilfsfeld für eine sichere Threadsynchronisierung
        private static object m_lock = new object();


        /// <summary>
        /// Fügt Schlüssel, die zum Entschlüsseln notwendig sind, hinzu.
        /// </summary>
        /// <param name="key">128-Bit-Schlüssel</param>
        public void AddKey(string key)
        {
            _keys.Add(key);
        }

        /// <summary>
        /// Vorgesehen zur Entschlüsslung von verschlüsselten Pocsagmeldungen
        /// </summary>
        /// <param name="input">verschlüsselter Nachrichtentext</param>
        /// <returns>entschlüsselten Nachrichtentext</returns>
        public string Decrypt(string input)
        {
            //--> eigene Implemenatation hier

            //In der Member List _keys befinden sich die Schlüssel

            string output = input;

            return output;
        }
    }
}
